/*
 *    Copyright  1996, 1997, 1998, 1999, 2000 by Remco Treffkorn
 *    Distributed under the terms of the Q Public License. Please see
 *    the included file LICENSE.
 */
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>

#include <X11/Xos.h>
#include <X11/cursorfont.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/FileSB.h>
#include <Xm/MainW.h>
#include <Xm/RowColumn.h>
#include <Xm/LabelG.h>
#include <Xm/Form.h>
#include <Xm/List.h>
#include <Xm/ScrollBar.h>
#include <X11/xpm.h>
 
#include "xmap.h"
#include "mode.h"
#include "debug.h"
#include "shapelib/shapefil.h"

extern Widget toplevel;
extern Widget draww;
extern GC clearGC;                                                                   

static char aep[PATH_MAX];
static char smapdir[PATH_MAX];

static struct layer {
    struct layer *next;
    double bounds[4];
    int entities;
    int shape_type;
    char *bname;
    char *lname;
    SHPHandle sh;
    char visible;
    char what;
} lroot;


static void clear(void)
{
    struct layer *t, *ls = lroot.next;

    while(ls) {
	t = ls;
	ls = ls->next;

	if (t->bname) free(t->bname);
	if (t->lname) free(t->lname);
	if (t->sh) SHPClose(t->sh);
    }
    lroot.next = NULL;
}

static void dumplayers(void)
{
    struct layer *t, *ls = lroot.next;

    while(ls) {
	t = ls;
	ls = ls->next;
	fprintf(stderr, "(%d) basename = \"%s\"  layer name = \"%s\"\n",
		t->visible, t->bname, t->lname);
	fprintf(stderr, "    entities = %d  shape type = %d\n", t->entities,
			t->shape_type);
	fprintf(stderr, "    bounds = %f  %f  %f  %f\n\n",
			t->bounds[0], t->bounds[1], t->bounds[2], t->bounds[3]);

    }
}

shape_map()
{
    int i;
    char *p, *q;
    char temp[PATH_MAX];
    char result[100];
    struct layer *t = &lroot;

    clear();
    sprintf(smapdir, "%s/%s", get_mapdir(), map.desname);
    smapdir[(int)(rindex(smapdir, '/')-smapdir)] = '\0';

    sprintf(aep, "%s/%s", get_mapdir(), map.desname);
    i = GetPrivateProfileInt("MAP", "LAYERCOUNT", 0, aep);

    while (i--) {
	sprintf(temp, "MAPLAYER%d", i);
	if (GetPrivateProfileString(temp, "BASE", "", result, 100, aep)) {
	    t->next = calloc(1, sizeof(struct layer));
	    t = t->next;
	    p = q = result;

	    while (*q && *q!=',') q++;
	    if (*q) *q++ = '\0';
	    t->what = atoi(p);

	    p=q;
	    while (*q && *q!=',') q++;
	    if (*q) *q++ = '\0';
	    p[(int)(rindex(p, '.')-p)] = '\0';
	    t->bname=strdup(p);
	    
	    p=q;
	    while (*q && *q!=',') q++;
	    if (*q) *q++ = '\0';
	    t->lname=strdup(p);
	    t->visible = GetPrivateProfileInt(temp, "VISIBLE", 0, aep);

	    sprintf(temp, "%s/%s.shp", smapdir, t->bname);
	    if ((t->sh = SHPOpen( temp, "rb" )) == NULL) t->visible = 0;
	    else {
		SHPReadBounds( t->sh, -1, t->bounds );
		SHPGetInfo( t->sh, &(t->entities), &(t->shape_type) );
	    }
	}
    }
    dumplayers();
}

do_shape()
{
}

csll()
{
}
